select
   cast(lpad(ass.codigoproprietario, 4, '0') as varchar(4)) as nfa
   , an.regassocraca
  , rac.codigoraca as raca
   , (case when
            --100% Mocha
            (an.cdanimal in (select cdanimal from animalraca where (cdraca = 305 and percentual = 100) or
                            (cdraca = 450 and percentual = 100) or (cdraca = 290 and percentual = 100)))
            then
              'M'
            else 'P' end) as variedade
  , gc.sigla as categoria
  , (case when (an.sexo = 'M') then 1 else 2 end) as sexo
  , cast((extract (year from an.dtnascimento)) as varchar(4)) as anonascto
  , an.seriealfa as serie
  , cast(an.rgn as varchar(16)) as rgn
  , cast(an.regassocraca as varchar(16)) as rgd
  , '' as nfo
  , 'BR' as iorreg
  , lpad(extract(day from an.dtnascimento),2,0) || '/' || lpad(extract(month from an.dtnascimento),2,0) || '/' || extract(year from an.dtnascimento) as dt_nasc
  , cast(penasc.peso as decimal(2,0)) as pn
  , (case when ((select re.numcria from reproducao re where re.cdreproducao = an.cdreproducao) = 2) then 2 else 1 end) as sn
  , pai.seriealfa as pai_ser
  , (coalesce(pai.regassocraca, pai.rgn)) as pai
  , (case when (pai.regassocraca is not null) then 'D' when ((pai.regassocraca is null) and (pai.rgn is not null)) then 'N' else '' end) as pai_tr
  , pairac.codigoraca as pai_rc
  , (case when
            --100% Mocha
            ((pai.cdanimal in (select cdanimal from animalraca where (cdraca = 305 and percentual = 100) or
                            (cdraca = 450 and percentual = 100) or (cdraca = 290 and percentual = 100))))
            then
              'M'
            when (pairac.codigoraca is not null) then 'P'
            else '' end) as pai_var
  , gcpai.sigla as pai_cat
  , '' as pai_nfo
  , 'BR' as pai_ior
  , (case when (pai.dtnascimento is not null) then (lpad(extract(day from pai.dtnascimento),2,0) || '/' || lpad(extract(month from pai.dtnascimento),2,0) || '/' || extract(year from pai.dtnascimento)) else null end) as pai_nascto
  , cast(mae.seriealfa as varchar(4)) as mae_ser
  --, cast(lpad(coalesce(mae.seriealfa, ''), 4, '') as varchar(4)) as mae_ser
  , (coalesce(mae.regassocraca, mae.rgn)) as mae
  , (case when (mae.regassocraca is not null) then 'D' when ((mae.regassocraca is null) and (mae.rgn is not null)) then 'N' else '' end) as mae_tr
  , maerac.codigoraca as mae_rc
  , (case when
            --100% Padrao
            ((mae.cdanimal in (select cdanimal from animalraca where (cdraca = 305 and percentual = 100) or
                            (cdraca = 450 and percentual = 100) or (cdraca = 290 and percentual = 100))))
            then
              'M'
            when (maerac.codigoraca is not null) then 'P'
            else '' end) as mae_var
  , gcmae.sigla as mae_cat
  , '' as mae_nfo
  , 'BR' as mae_ior
  , (case when (mae.dtnascimento is not null) then (lpad(extract(day from mae.dtnascimento),2,0) || '/' || lpad(extract(month from mae.dtnascimento),2,0) || '/' || extract(year from mae.dtnascimento)) else null end) mae_nascto
  , cast(lpad((select count(*) from reproducao re where re.cdanimal = par.cdanimal and re.cdtiporeproducao = 7 and re.data <= par.data), 2, '0') as varchar(2)) as np
  , (case when ((cob.cdtiporeproducao = 2) and (cob.cddiagnostico is null))
              then 1
            when ((cob.cdtiporeproducao = 2) and (cob.cddiagnostico is not null))
              then 2
            when ((cob.cdtiporeproducao = 1) and (cob.condicaoia <> 'I'))
              then 3
            when (cob.cdtiporeproducao = 3)
              then 4
            when ((cob.cdtiporeproducao = 1) and (cob.condicaoia = 'I'))
              then 6 else '' end) as ta
  , (case when (cob.data is not null) then (lpad(extract(day from cob.data),2,0) || '/' || lpad(extract(month from cob.data),2,0) || '/' || extract(year from cob.data)) else null end) acasala
  , (select count(*) from reproducao re where re.cdanimal = par.cdanimal and re.cdtiporeproducao in (1,2,3) and re.data < par.data
        and re.data > coalesce(parant.data, '1900-01-01')) as nc
  , (case when (par.cdtipoparto = 1) then '1'
            when ((par.cdtipoparto = 2) and (par.cdauxilioparto in (4,3,1))) then '2'
            when ((par.cdtipoparto = 2) and (par.cdauxilioparto = 2)) then '3'
            when (par.cdtipoparto = 4) then '4' else '' end) as op
  , (case when (pe.cdpeso is not null) then (lpad(pe.peso, 3, 0)) else null end)  as pvp
  , g1.cdregimealimentar as mpvp
  , g1.descricao as lotepvp
  , an.nomecompleto as nome
from
  associacao ass
  join animal an on 1 = 1
  left join graucruzamento gc on gc.cdgraucruzamento = an.cdgraucruzamento
  left join peso penasc on penasc.cdpeso =
    (select first 1 re.cdpeso from peso re where re.cdanimal = an.cdanimal and re.cdtipopeso in (1,2) and re.dtpeso = an.dtnascimento)
  left join animal pai on pai.cdanimal = an.cdpai
  left join graucruzamento gcpai on gcpai.cdgraucruzamento = pai.cdgraucruzamento
  left join animal mae on mae.cdanimal = an.cdmae
  join sp_retornaracaancp(an.cdanimal) rac on 1 = 1 and rac.codigoraca <> ''
  left join sp_retornaracaancp(pai.cdanimal) pairac on 1 = 1
  left join sp_retornaracaancp(mae.cdanimal) maerac on 1 = 1
  left join graucruzamento gcmae on gcmae.cdgraucruzamento = mae.cdgraucruzamento
  left join reproducao par on par.cdreproducao = an.cdreproducao
  left join reproducao cob on cob.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = par.cdanimal and re.cdtiporeproducao in (1,2,3) and
            re.data < par.data order by re.data desc)
  left join reproducao parant on parant.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = par.cdanimal and re.cdtiporeproducao = 7 and
            re.data < par.data order by re.data desc)
  left join tipoparto tp on tp.cdtipoparto = par.cdtipoparto
  left join peso pe on pe.cdanimal = par.cdanimal and pe.dtpeso = par.data
  left join movgrupo m1 on m1.cdmovgrupo =
    (select first 1 re.cdmovgrupo from movgrupo re join movgrupoanimal rea on rea.cdmovgrupo = re.cdmovgrupo where
        rea.cdanimal = par.cdanimal and re.cdtipogrupoanimal = (select valor from configuracao where nome = 'TipoGrupoPrincipal')
            and re.dtmovimentacao <= par.data order by re.dtmovimentacao desc)
  left join grupoanimal g1 on g1.cdgrupoanimal = m1.cdgrupoanimal
  left join regimealimentar ra on ra.cdregimealimentar = g1.cdregimealimentar
  join setor se on se.cdsetor = an.cdsetor
where
  an.dtbaixa is null
  and an.tipoanimal = 'A'
  and an.animalrebanho = 1
  --Busca da nfa no cadastro da associacao
  and ass.numero = 100
  --Filtro de sexo
  and an.sexo in ('F','M')
  --Filtro de setor - NMERO - preencher com o numero do setor
  and se.numero in ('1', '2', '3', '4', '5')
  --Perodo de nascimento no formato AAA-MM-DD
  and an.dtnascimento between '2000-01-01' and '2014-08-14'
  -- Tirar animais sem regime alimentar (solicitao do Danilo no fim de 2019)
  and g1.cdregimealimentar is not null  
